<template>
  <div class="el-container-md">

    <el-form :model="queryParams" class="live-goods-css" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="商品名称" prop="keywords" >
        <el-input
          v-model="queryParams.keywords"
          placeholder="请输入商品名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="上下架" prop="status" >
        <el-input
          v-model="queryParams.status"
          placeholder="请输入直播间状态"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <div class="selection-toolbar">
      <el-checkbox :indeterminate="isIndeterminate" v-model="allChecked" @change="toggleSelectAll">
        {{ multipleSelection.length > 0 ? `已选 ${multipleSelection.length} 条` : '选中本页' }}
      </el-checkbox>
      <el-button  plain size="mini" @click="handleShelf">上架</el-button>
      <el-button  plain size="mini" @click="handleUnshelf">下架</el-button>
      <el-button  plain size="mini" @click="handleDeleteSelected">删除</el-button>
      <el-button  plain type="mini" icon="el-icon-plus" @click="handleAddLiveGoods">添加商品</el-button>
    </div>
    <el-table
      ref="goodTable"
      :data="goodsLiveList"
      style="width: 100%"
      v-loading="loading"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <!-- 题干列：显示试题的主要内容 -->
      <el-table-column
        prop="goodsId"
        label="商品id"
        show-overflow-tooltip
      ></el-table-column>

      <el-table-column
        label="商品图片"
      >
        <template slot-scope="scope">
          <img
            :src="scope.row.imgUrl"
            style="display: block; max-width: 100%; width: 100px; height: 100px"
          />
        </template>

      </el-table-column>

      <el-table-column
        prop="productName"
        label="商品名称"
      ></el-table-column>

      <el-table-column
        prop="price"
        label="价格"
      ></el-table-column>

      <el-table-column
        prop="stock"
        label="库存"
      ></el-table-column>

      <el-table-column
        prop="sales"
        label="销量"
      ></el-table-column>

      <el-table-column
        prop="status"
        label="上下架"
      >
        <template slot-scope="scope">
          <el-tag v-if="scope.row.status == 1">上架</el-tag>
          <el-tag v-if="scope.row.status == 0">下架</el-tag>
        </template>
      </el-table-column>

      <!-- 操作列：包含编辑和删除按钮 -->
      <el-table-column
        label="操作"
        width="180"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            type="text"
            size="small"
            style="color: #F56C6C;"
            @click="handleGoodDelete(scope.row)"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 分页组件：用于分页展示试题列表 -->
    <pagination
      v-show="goodsLiveTotal > 0"
      :total="goodsLiveTotal"
      :page.sync="goodsParams.pageNum"
      :limit.sync="goodsParams.pageSize"
      @pagination="getLiveGoodsList"
      style="margin-top: 20px;"
    />

    <!-- 添加商品弹窗 -->
    <el-dialog
      title="添加商品"
      :visible.sync="goodsDialogVisible"
      width="800px"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
    >
      <div class="dialog-content">
        <div style="text-align: right; margin-bottom: 20px;">
          <el-input
            v-model="searchTitle"
            placeholder="请输入产品名称"
            style="width: 300px;"
            @input="handleGoodsSearch"
          ></el-input>
        </div>

        <el-table
          :data="goodsList"
          style="width: 100%"
          v-loading="goodsLoading"
          @selection-change="handleGoodsChange"
          @row-click="handleGoodsRowClick"
          row-key="id"
        >
          <el-table-column
            type="selection"
            width="55"
          >
          </el-table-column>
          <el-table-column
            prop="storeName"
            label="商铺名称"
            class-name="clickable-column"
          ></el-table-column>
          <el-table-column
            prop="productName"
            label="产品"
            class-name="clickable-column"
          ></el-table-column>
          <el-table-column
            prop="price"
            label="价格"
            class-name="clickable-column"
          ></el-table-column>
          <el-table-column
            prop="stock"
            label="库存"
            class-name="clickable-column"
          ></el-table-column>
        </el-table>

        <pagination
          v-show="goodsTotal > 0"
          :total="goodsTotal"
          :page.sync="queryGoodParams.pageNum"
          :limit.sync="queryGoodParams.pageSize"
          @pagination="getStoreProductLists"
          style="margin-top: 20px;"
        />
      </div>
      <div slot="footer" class="dialog-footer">
        <div style="display: flex; justify-content: space-between; align-items: center;">
          <span class="selected-count">当前已选择 <span style="color: #00BFFF; font-style: italic;">{{ selectedGoods.length }}</span> 商品</span>
          <div>
            <el-button @click="goodsDialogVisible = false">取 消</el-button>
            <el-button type="primary" @click="confirmAddGoods">确 定</el-button>
          </div>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {addLiveGoods, delLiveGoods, listLiveGoods, listStoreProduct, handleShelfOrUn, handleDeleteSelected} from "@/api/live/liveGoods";

export default {
  data() {
    return {
      liveId: '',
      loading: true,
      searchTitle: '',
      queryGoodParams: {
        pageNum: 1,
        pageSize: 10,
        productName: null,
        liveId: null
      },
      // 显示搜索条件
      showSearch: true,
      goodsLiveList: [],
      goodsLiveTotal: 0,
      goodsParams: {
        pageNum: 1,
        pageSize: 10,
        liveId: null
      },
      goodsList: [],
      goodsTotal: 0,
      selectedGoods: [],
      goodsLoading: false,
      goodsDialogVisible: false,
      multipleSelection: [],
      allChecked: false,
      isIndeterminate: false,
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        keywords: null,
        status: null,
        liveId: null,
        desc: null,
        createTime: null,
        updateTime: null,
      },
    };
  },
  created() {
    this.liveId = this.$route.query.liveId
    this.goodsParams.liveId = this.liveId
    this.queryParams.liveId = this.liveId
    this.getLiveGoodsList();
  },
  methods: {
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.loading = true
      listLiveGoods(this.queryParams).then(response => {
        this.goodsLiveList = response.rows
        this.goodsLiveTotal = response.total
        this.loading = false
      })
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.$refs.queryForm.resetFields();
    },
    handleShelf(){
      this.handleShelfOrUn(1)
    },
    handleUnshelf(){
      this.handleShelfOrUn(0)
    },
    handleShelfOrUn(type){
      if (this.multipleSelection.length > 0) {
        const goodsList = this.getSelectedList();
        handleShelfOrUn({"goodsIds":goodsList,"status":type}).then(res=>{
          this.dealResult(res)
        })
      } else {
        this.$message.info("请选择下架商品！")
      }
    },
    handleDeleteSelected(){
      if (this.multipleSelection.length > 0) {
        const goodsList = this.getSelectedList();
        handleDeleteSelected({"goodsIds":goodsList}).then(res=>{
          this.dealResult(res)
        })
      } else {
        this.$message.info("请选择被删除的商品！")
      }
    },
    dealResult(res){
      if (res.code == 200) {
        this.getLiveGoodsList();
        this.$refs.goodTable.clearSelection();
      } else {
        this.$message.error(res.msg);
      }
    },
    getSelectedList(){
      var goodsList = []
      this.multipleSelection.forEach(item => {
        goodsList.push(item.goodsId);
      })
      return goodsList;
    },
    // 全选或取消全选
    toggleSelectAll(val) {
      this.checked = val; // 更新 checkbox 的状态
      if (val) {
        // 如果 checkbox 被选中，则全选
        this.toggleSelection(this.goodsLiveList);
      } else {
        // 如果 checkbox 被取消选中，则取消全选
        this.toggleSelection();
      }
    },
    toggleSelection(rows) {
      if (rows && !this.isIndeterminate) {
        rows.forEach(row => {
          this.$refs.goodTable.toggleRowSelection(row);
        });
      } else {
        this.$refs.goodTable.clearSelection();
      }
    },
    // 多选框选中数据
    handleSelectionChange(val) {
      this.multipleSelection = val;
      // 根据选择项的数量更新 checkbox 的状态
      this.allChecked = val.length === this.goodsLiveList.length;
      this.isIndeterminate = val.length > 0 && val.length < this.goodsLiveList.length;
    },

    getLiveGoodsList() {
      this.loading = true
      listLiveGoods(this.goodsParams).then(response => {
        this.goodsLiveList = response.rows
        this.goodsLiveTotal = response.total
        this.loading = false
      })
    },
    handleAddLiveGoods(){
      this.goodsDialogVisible = true;
      this.getStoreProductLists()
    },
    handleGoodsSearch(){
      this.queryGoodParams.pageNum = 1
      this.queryGoodParams.productName = this.searchTitle
      this.getStoreProductLists()
    },
    handleGoodsChange(goods) {
      this.selectedGoods = goods
    },
    confirmAddGoods(){
      if (this.selectedGoods.length === 0) {
        this.$message({
          message: '请选择要添加的商品',
          type: 'warning'
        })
        return
      }
      addLiveGoods({
        liveId: this.liveId,
        productsId: this.selectedGoods.map(item => item.productId).join(',')
      }).then(response => {
        this.goodsDialogVisible = false
        this.getLiveGoodsList()
      })
    },
    handleGoodDelete(row){
      delLiveGoods(row.goodsId).then(response => {
        this.getLiveGoodsList()
      })
    },
    /** 处理行点击事件 */
    handleGoodsRowClick(row, column) {
      // 如果点击的是复选框列，不进行处理
      if (column.type === 'selection') {
        return
      }

      // 获取表格实例
      const table = this.$refs.goodsTable[0]
      if (!table) {
        return
      }

      // 判断当前行是否已经被选中
      const isSelected = this.selectedGoods.some(item => item.id === row.id)

      // 切换选中状态
      table.toggleRowSelection(row, !isSelected)
    },
    getStoreProductLists() {
      this.queryGoodParams.liveId = this.liveId
      listStoreProduct(this.queryGoodParams).then(response => {
        this.goodsList = response.rows
        this.goodsTotal = response.total
        this.loading = false
      })
    }

  }
};
</script>

<style scoped>
.selection-toolbar {
  display: flex;
  align-items: center;
  margin-bottom: 10px;
  padding-left: 10px;
}

.selection-toolbar .el-checkbox {
  margin-right: 10px;
}

/* 调整 checkbox 内部输入框的对齐 */
.selection-toolbar .el-checkbox .el-checkbox__inner {
  top: 8px; /* 根据实际需求调整 */
}

.live-goods-css {
  padding-left: 10px;
  padding-top: 30px;
}
</style>
